### Function

# FwupdPlugin memstrsafe

since: 1.9.3

#### Declaration [src]

    gchar*
    fu_memstrsafe (
      const guint8* buf,
      gsize bufsz,
      gsize offset,
      gsize maxsz,
      GError** error
    )

#### Description [src]

Converts a byte buffer to a ASCII string.

Available since: 1.9.3

#### Parameters

`buf`

  Type: `const guint8*`

  Source buffer.

  The data is owned by the caller of the function.

`bufsz`

  Type: `gsize`

  Maximum size of `buf`, typically `sizeof(buf)`.

`offset`

  Type: `gsize`

  Offset in bytes into `buf` to read from.

`maxsz`

  Type: `gsize`

  Maximum size of returned string.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gchar*`

A string, or `NULL` on error.

The caller of the function takes ownership of the data, and is responsible for freeing it.
The value is a NUL terminated UTF-8 string.